/*
   $BHW$KBP$9$kA`:n$r=8$a$F$$$^$9!#(B
*/

#include "renju.h"
#include "prototype.h"

void clear_board(board_t b)
{
    int i, j;

    for (i = -OUTSIZE; i < BOARDSIZE + OUTSIZE; i++)
	for (j = -OUTSIZE; j < BOARDSIZE + OUTSIZE; j++)
	    BAN(b, j, i).koma = K_WALL;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++) {
	    BAN(b, j, i).koma = K_NOTHING;
	    BAN(b, j, i).value[K_BLACK] = BAN(b, j, i).value[K_WHITE] = T_0;
	    BAN(b, j, i).lose[K_BLACK] = BAN(b, j, i).lose[K_WHITE] = T_0;
	}
    BAN(b, BOARDSIZE/2, BOARDSIZE/2).koma = K_CENTER;
}

void put_koma(board_t b, int n, int x, int y)
{
    int i, j;

    BAN(b, x, y).koma = n & 1;
    BAN(b, x, y).value[K_BLACK] = BAN(b, x, y).value[K_WHITE] = T_0;

    for (i = y - CHECKSIZE; i <= y + CHECKSIZE; i++)
	for (j = x - CHECKSIZE; j <= x + CHECKSIZE; j++)
	    if (BAN(b, j, i).koma == K_NOTHING)
		BAN(b, j, i).koma = K_CHECK;

    for (i = 0; i < 4; i++)
	for (j = 1; j <= OUTSIZE; j++) {
	    if (BAN(b, x - dircx[i] * j, y - dircy[i] * j).koma == K_CHECK)
		check_xy(b, x - dircx[i] * j, y - dircy[i] * j);
	    if (BAN(b, x + dircx[i] * j, y + dircy[i] * j).koma == K_CHECK)
		check_xy(b, x + dircx[i] * j, y + dircy[i] * j);
	}
}

int do_pass(board_t b, int n)
{
    int i, j;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK &&
		BAN(b, j, i).lose[n & 1] != T_LOSE)
		return 0;
    return 1;
}
