/*
   $B$3$N%k!<%A%s$GHW$+$i#3$d#4$J$I$,$I$&$J$C$F$$$k$+D4$Y$^$9!#(B

   $B>\$7$/$O!"(B

   @OO OOO OO
   ^----- $B$3$3$K$*$$$?;~$K$3$l$r(B
   fl(flag left) = 1        $B:8B&$,;_$a$i$l$F$$$k$+(B
   nl(number left) = 2      $B:8$KHt$s$@$H$3$m$K$I$N$/$i$$@P$,$"$k$+(B
   nm(number middle) = 3    $BCV$$$?$H$3$m$N$^$o$j$K$I$N$/$i$$@P$,$"$k$+(B
   nr(number right) = 2     $B1&$KHt$s$@$H$3$m$K$I$N$/$i$$@P$,$"$k$+(B
   fr(flag right) = 0       $B1&B&$,;_$a$i$l$F$$$k$+(B
   $B$HJ,2r$7$^$9!#$3$NCM$+$i$3$l$,2?$+$rD4$Y$^$9!#(B
   $B$3$N>l9g$OHt$SD9O"$H$J$j$^$9!#(B

   --- $BNc(B
   fl, nl, nm, nr, fr
   OOO
   ^----- 0, 0, 3, 0, 0 ---> 3
   @O OO
   ^---- 1, 1, 2, 0, 0 ---> 2
   @OOOO @
   ^----- 1, 0, 4, 0, 0 ---> 4
   @ OOO@
   ^----- -1, 0, 3, 0, 1 ---> 4

   $B$H$$$C$?6q9g$G$9!#(B

   $B8eH>$N%A%'%C%/ItJ,$O%P%0$,$"$k$+$b$7$l$^$;$s!#(B
   # $B<B:]$KO"<n$N:Y$+$$ItJ,$,%A%'%C%/$G$-$F$$$^$;$s$G$7$?!#(B
   # $B%P%0$,$"$j$^$9!#(B

*/

#include <stdio.h>
#include "renju.h"
#include "prototype.h"

int dircx[] =
{0, 1, 1, 1};
int dircy[] =
{-1, -1, 0, 1};

static void check_dir(board_t b, int x, int y, int dx, int dy,
		      int nm[2], int n[2], int f[2])
{
    int xx, yy;
    int k;

    xx = x + dx;
    yy = y + dy;

    switch (k = BAN(b, xx, yy).koma) {
    case K_BLACK:
    case K_WHITE:
	f[1 - k] = 1;
	do {
	    nm[k]++;
	    xx += dx;
	    yy += dy;
	} while (BAN(b, xx, yy).koma == k);

	if (BAN(b, xx, yy).koma <= K_WALL)
	    f[k] = 1;
	else {
	    xx += dx;
	    yy += dy;
	    while (BAN(b, xx, yy).koma == k) {
		n[k]++;
		xx += dx;
		yy += dy;
	    }
	    if (BAN(b, xx, yy).koma <= K_WALL)
		if (n[k])
		    f[k] = 1;
		else
		    f[k] = -1;
	}
	break;

    case K_WALL:
	f[K_BLACK] = f[K_WHITE] = 1;
	break;

    case K_NOTHING:
    case K_CHECK:
	xx += dx;
	yy += dy;
	switch (k = BAN(b, xx, yy).koma) {
	case K_BLACK:
	case K_WHITE:
	    f[1-k] = -1;
	    do {
		n[k]++;
		xx += dx;
		yy += dy;
	    } while (BAN(b, xx, yy).koma == k);

	    if (BAN(b, xx, yy).koma <= K_WALL)
		f[k] = 1;
	    break;
	case K_WALL:
	    f[K_BLACK] = f[K_WHITE] = -1;
	    break;

	case K_NOTHING:
	case K_CHECK:
	    break;
	}
	break;

    }

}

static void make_value(int nn[T_L + 1], int nl, int nm, int nr, int fl, int fr)
{
    if (nm == 5)
	nn[T_5]++;
    else if (nm > 5)
	nn[T_L]++;
    else if (nr == 0 && nl == 0)
	switch (nm) {
	case 2:
	    if (fr == 0 && fl == 0)
		nn[T_2]++;
	    break;
	case 3:
	    if ((fr <= 0 && fl == 0) || (fr == 0 && fl <= 0))
		nn[T_3]++;
	    else if (fr == -1 && fl == -1)
		nn[T_S3]++;
	    break;
	case 4:
	    if (fr <= 0 && fl <= 0)
		nn[T_R4]++;
	    else if (fr <= 0 || fl <= 0)
		nn[T_4]++;
	    break;
    } else if (nr == 0) {
	if (nm == 4 && !fr)
	    nn[T_R4]++;
	else if (nm + nl == 3 && !fr && !fl)
	    nn[T_T3]++;
	else if (nm + nl == 4)
	    nn[T_T4]++;
	else if (nm + nl > 4)
	    nn[T_TL]++;
    } else if (nl == 0) {
	if (nm == 4 && !fl)
	    nn[T_R4]++;
	else if (nr + nm == 3 && !fr && !fl)
	    nn[T_T3]++;
	else if (nr + nm == 4)
	    nn[T_T4]++;
	else if (nr + nm > 4)
	    nn[T_TL]++;
    } else if (nr + nm == 3 && nm + nl == 3 && (fr | fl))
	nn[T_T3]++;
    else if (nr + nm > 4 && nm + nl > 4)
	nn[T_TL] += 2;
    else if (nr + nm > 4 && nm + nl == 4) {
	nn[T_T4]++;
	nn[T_TL]++;
    } else if (nr + nm == 4 && nm + nl > 4) {
	nn[T_T4]++;
	nn[T_TL]++;
    } else if (nr + nm > 4 || nm + nl > 4)
	nn[T_TL]++;
    else if (nr + nm == 4 || nm + nl == 4)
	nn[T_T4]++;
}

static void set_value_black(board_t b, int x, int y, int n, int nn[T_L + 1])
{
    if (nn[T_5])
	BAN(b, x, y).value[n] = T_5;
    else if (nn[T_3] + nn[T_T3] >= 2)
	BAN(b, x, y).value[n] = T_33;
    else if (nn[T_L])
	BAN(b, x, y).value[n] = T_L;
    else if (nn[T_R4] + nn[T_T4] + nn[T_4] >= 2)
	BAN(b, x, y).value[n] = T_44;
    else if (nn[T_R4] + nn[T_T4] + nn[T_4]
	     && nn[T_T3] + nn[T_3])
	BAN(b, x, y).value[n] = T_43;
    else if (nn[T_R4])
	BAN(b, x, y).value[n] = T_R4;
    else if (nn[T_T4])
	BAN(b, x, y).value[n] = T_T4;
    else if (nn[T_4])
	BAN(b, x, y).value[n] = T_4;
    else if (nn[T_T3])
	BAN(b, x, y).value[n] = T_T3;
    else if (nn[T_3])
	BAN(b, x, y).value[n] = T_3;
    else if (nn[T_S3])
	BAN(b, x, y).value[n] = T_S3;
    else if (nn[T_2])
	BAN(b, x, y).value[n] = T_2;
    else if (nn[T_TL])
	BAN(b, x, y).value[n] = T_TL;
    else
	BAN(b, x, y).value[n] = T_0;

    if (BAN(b, x, y).value[n] == T_33 ||
	BAN(b, x, y).value[n] == T_44 ||
	BAN(b, x, y).value[n] == T_L)
	BAN(b, x, y).lose[n] = T_LOSE;
    else
	BAN(b, x, y).lose[n] = BAN(b, x, y).value[n];
}

static void set_value_white(board_t b, int x, int y, int n, int nn[T_L + 1])
{
    if (nn[T_3] + nn[T_T3] >= 2)
	BAN(b, x, y).value[n] = T_33;
    else if (nn[T_R4] + nn[T_T4] + nn[T_4] + nn[T_TL] >= 2)
	BAN(b, x, y).value[n] = T_44;
    else if (nn[T_L])
	BAN(b, x, y).value[n] = T_L;
    else if (nn[T_5])
	BAN(b, x, y).value[n] = T_5;
    else if (nn[T_R4] + nn[T_T4] + nn[T_4] + nn[T_TL]
	     && nn[T_T3] + nn[T_3])
	BAN(b, x, y).value[n] = T_43;
    else if (nn[T_R4])
	BAN(b, x, y).value[n] = T_R4;
    else if (nn[T_T4])
	BAN(b, x, y).value[n] = T_T4;
    else if (nn[T_TL])
	BAN(b, x, y).value[n] = T_TL;
    else if (nn[T_4])
	BAN(b, x, y).value[n] = T_4;
    else if (nn[T_T3])
	BAN(b, x, y).value[n] = T_T3;
    else if (nn[T_3])
	BAN(b, x, y).value[n] = T_3;
    else if (nn[T_S3])
	BAN(b, x, y).value[n] = T_S3;
    else if (nn[T_2])
	BAN(b, x, y).value[n] = T_2;
    else
	BAN(b, x, y).value[n] = T_0;

    if (BAN(b, x, y).value[n] == T_L)
	BAN(b, x, y).lose[n] = T_WIN;
    else
	BAN(b, x, y).lose[n] = BAN(b, x, y).value[n];
}

void check_xy(board_t b, int x, int y)
{
    int nr[2], nm[2], nl[2], fr[2], fl[2];
    int d, i;
    int nn[2][T_L + 1];

    for (i = 0; i < T_L + 1; i++)
	nn[K_BLACK][i] = nn[K_WHITE][i] = 0;

    for (d = 0; d < 4; d++) {
	nm[K_BLACK] = nm[K_WHITE] = 1;
	nr[K_BLACK] = nl[K_BLACK] = nr[K_WHITE] = nl[K_WHITE] = 0;
	fr[K_BLACK] = fl[K_BLACK] = fr[K_WHITE] = fl[K_WHITE] = 0;

	check_dir(b, x, y, -dircx[d], -dircy[d], nm, nr, fr);

	check_dir(b, x, y, dircx[d], dircy[d], nm, nl, fl);

	for (i = 0; i < K_WHITE + 1; i++)
	    make_value(nn[i], nl[i], nm[i], nr[i], fl[i], fr[i]);
    }

    set_value_black(b, x, y, K_BLACK, nn[K_BLACK]);
    set_value_white(b, x, y, K_WHITE, nn[K_WHITE]);

}
