/*
   $B30It;W9M%k!<%A%s$H$N%$%s%?!<%U%'!<%9It(B
*/

#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>

#include "renju.h"
#include "renjucmd.h"

void init_pipe(char *tname, FILE **CmdIn, FILE **CmdOut)
{
    int pfd1[2];		/* from server to client */
    int pfd2[2];		/* from clinet to server */

    if (pipe(pfd1)) {
	fprintf(stderr, "Cannot create pipe\n");
	exit(1);
    }
    if (pipe(pfd2)) {
	fprintf(stderr, "Cannot create pipe\n");
	exit(1);
    }

    if (fork() == 0) {
	*CmdOut = fdopen(pfd1[1], "w");
	*CmdIn = fdopen(pfd2[0], "r");
	if (*CmdOut == NULL) {
	    fprintf(stderr, "CmdOut cannot open\n");
	    exit(2);
	}
	if (*CmdIn == NULL) {
	    fprintf(stderr, "CmdIn cannot open\n");
	    exit(2);
	}
	close(pfd1[0]);
	close(pfd2[1]);
    } else {
	close(pfd1[1]);
	close(pfd2[0]);
	dup2(pfd1[0], 0);	/* fdout -> stdin */
	dup2(pfd2[1], 1);	/* stdout -> fdin */
	execlp(tname, tname, NULL);
	fprintf(stderr, "cannot execute %s\n", tname);
	exit(99);
    }
}

