#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include "renju.h"
#include "xrenju.h"
#include "prototype.h"

static struct messageResources_s {
    String sLose;	/* $BIi$1(B($B9u$N(B33$B!"D9O"(B) */
    String sNone;	/* $B2?$b$J$7(B */
    String s2;		/* 2 */
    String sS3;		/* $B;_$^$C$?(B3 */
    String sT3;		/* $BHt$S(B3 */
    String s3;		/* 3 */
    String sT4;		/* $BHt$S(B4 */
    String sTL;		/* $BHt$SD9O"(B */
    String s4;		/* 4 */
    String s33;		/* 33 */
    String s43;		/* 43 */
    String s44;		/* 44 */
    String sR4;		/* 4$BO"(B($B;_$^$C$F$$$J$$(B4) */
    String s5;		/* 5 */
    String sL;		/* $BD9O"(B */
    String warning;
    String blackwon;
    String whitewon;
    String drawgame;
} messageResources;

char *messages[T_L+1];
char *warning;
char *messageWon[2];
char *drawgame;

#define xoffset(entry)	XtOffset(struct messageResources_s *, entry)
#define reslist(name, class, entry, default) \
	    {name, class, XtRString, sizeof(String), \
		    xoffset(entry), XtRString, default}

static XtResource resources[] = {
    reslist("sLose", "MessageLose", sLose, "Kin-ji-te"),
    reslist("sNone", "MessageNone", sNone, ""),
    reslist("s2", "Message2", s2, ""),
    reslist("sS3", "MessageStop3", sS3, ""),
    reslist("sT3", "MessageTobi3", sT3, "Tobi 3"),
    reslist("s3", "Message3", s3, "3"),
    reslist("sT4", "MessageTobi4", sT4, "Tobi 4"),
    reslist("sTL", "MessageTobiTyouren", sTL, "Tobi Tyou-ren"),
    reslist("s4", "Message4", s4, "4"),
    reslist("s33", "Message33", s33, "33"),
    reslist("s43", "Message43", s43, "43"),
    reslist("s44", "Message44", s44, "44"),
    reslist("sR4", "MessageR4", sR4, "4-ren"),
    reslist("s5", "Message5", s5, "5"),
    reslist("sL", "MessageTyouren", sL, "Tyou-ren"),
    reslist("warning", "MessageWarning", warning, "Are you sure?"),
    reslist("blackwon", "MessageBlackWon", blackwon, "Black won."),
    reslist("whitewon", "MessageWhiteWon", whitewon, "White won."),
    reslist("drawgame", "MessageDrawGame", drawgame, "Draw Game."),
};

void getMessage(void)
{
    XtVaGetApplicationResources(rootW, &messageResources,
		resources, XtNumber(resources), NULL);
    messages[T_LOSE] = messageResources.sLose;
    messages[T_0] = messageResources.sNone;
    messages[T_2] = messageResources.s2;
    messages[T_S3] = messageResources.sS3;
    messages[T_T3] = messageResources.sT3;
    messages[T_3] = messageResources.s3;
    messages[T_T4] = messageResources.sT4;
    messages[T_TL] = messageResources.sTL;
    messages[T_4] = messageResources.s4;
    messages[T_33] = messageResources.s33;
    messages[T_43] = messageResources.s43;
    messages[T_44] = messageResources.s44;
    messages[T_R4] = messageResources.sR4;
    messages[T_5] = messageResources.s5;
    messages[T_L] = messageResources.sL;

    warning = messageResources.warning;
    messageWon[K_BLACK] = messageResources.blackwon;
    messageWon[K_WHITE] = messageResources.whitewon;
    drawgame = messageResources.drawgame;
}
