/*
   $B30It%3%^%s%I$H$N%a%C%;!<%8MQ$N4X?t$G$9!#(B
*/

#include <stdio.h>
#include <ctype.h>

#include "renju.h"
#include "renjucmd.h"

char *posMsg = "%2d - %c";

char *posMessage(char *str, int x, int y)
{
    sprintf(str, posMsg, x + 1, y + 'A');

    return str;
}

void getPos(char *str, int *px, int *py)
{
    int x;
    char c;
    int f;

    f = sscanf(str, posMsg, &x, &c);
    if (f != 2) {
	fprintf(stderr, "'%s' isn't position message form. '%s'\n",
		str, posMsg);
	exit(1);
    }
    if (islower(c))
	c = toupper(c);
    *px = x - 1;
    *py = c - 'A';
}

void WriteCmdStr(char *buf, RenjuCmd cmd)
{
    char str[1024];

    switch (cmd.type) {
    case CMD_INIT:
	strcpy(buf, "Initialize\n");
	break;

    case CMD_PUT:
	sprintf(buf, "Put %s\n", posMessage(str, cmd.x, cmd.y));
	break;

    case CMD_THINK:
	strcpy(buf, "Think\n");
	break;

    case CMD_END:
	strcpy(buf, "End\n");
	break;

    case CMD_SKIP:
	strcpy(buf, "Skip(Pass)\n");
	break;

    }
}

void WriteCmdFile(FILE *fdout, RenjuCmd cmd)
{
    char buf[1024];

    WriteCmdStr(buf, cmd);
    fputs(buf, fdout);
    fflush(fdout);
}


RenjuCmd ReadCmdStr(char *buf)
{
    char *p;
    RenjuCmd cmd;

    p = buf;

    while (isspace(*p))
	p++;

    switch (*p) {
    case 'I':
    case 'i':
	cmd.type = CMD_INIT;
	break;

    case 'P':
    case 'p':
	cmd.type = CMD_PUT;

	while (!isspace(*p))
	    p++;
	while (isspace(*p))
	    p++;

	getPos(p, &cmd.x, &cmd.y);
	break;

    case 'T':
    case 't':
	cmd.type = CMD_THINK;
	break;

    case 'S':
    case 's':
	cmd.type = CMD_SKIP;
	break;

    case 'E':
    case 'e':
	cmd.type = CMD_END;
	break;

    case 'H':
    case 'h':
	cmd.type = CMD_HELP;
	break;

    default:
	cmd.type = '?';
	break;
    }
    return cmd;
}

RenjuCmd ReadCmdFile(FILE *fdin)
{
    char buf[1024];
    RenjuCmd cmd;

    do {
	if (fgets(buf, sizeof(buf), fdin) == NULL) {
	    cmd.type = CMD_END;
	    return cmd;
	}
	cmd = ReadCmdStr(buf);
    } while (cmd.type == '?');
    return cmd;
}
