/*
   $B8^L\JB$Y$N%3%s%T%e!<%?$N;W9M%k!<%A%s(B
   $B2~NI$NM>CO$O$?$/$5$s$"$j$^$9!#(B
   $B;W9M4X78$N%k!<%A%s$N@bL@$O3F%k!<%A%s$NF,$K$D$$$F$^$9!#(B
*/

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include "renju.h"
#include "renjucmd.h"
#include "prototype.h"

#define CNT_SIZE        (T_WIN+1)

#if defined(SYSV) || defined(_POSIX_SOURCE)
#define cpboard(s, d)	memcpy(d, s, sizeof(board_t))
#define	Random	lrand48
#else
#define cpboard(s, d)	bcopy(s, d, sizeof(board_t))
#define	Random	random
#endif

typedef struct {
    short n;
    char x, y;
} counter_t[2][CNT_SIZE];

/*  count
   $B3F%k!<%A%s$G$N;qNA$H$7$F!"$I$N<j$,$I$N$/$i$$$"$k$+$r?t$($^$9!#(B
 */
static void count(board_t b, counter_t c)
{
    int i, j;

    for (i = 0; i < CNT_SIZE; i++)
	c[K_BLACK][i].n = c[K_WHITE][i].n = 0;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK) {
		c[K_BLACK][BAN(b, j, i).lose[K_BLACK]].n++;
		c[K_BLACK][BAN(b, j, i).lose[K_BLACK]].x = j;
		c[K_BLACK][BAN(b, j, i).lose[K_BLACK]].y = i;

		c[K_WHITE][BAN(b, j, i).lose[K_WHITE]].n++;
		c[K_WHITE][BAN(b, j, i).lose[K_WHITE]].x = j;
		c[K_WHITE][BAN(b, j, i).lose[K_WHITE]].y = i;
	    }
}

/*  count_n
   count $B$G$N7k2L$+$i$"$k<j$h$j6/$$<j$,$I$N$/$i$$$"$k$+$rD4$Y$^$9!#(B
   $B<j$N6/$5$O(B renju.h $B$N(B #define $BJ8$N(B T_... $B$NCM$G$9!#(B
 */
static int count_n(counter_t c, int mn, int t)
{
    int i;
    int x;

    x = 0;

    for (i = t; i <= T_WIN; i++)
	x += c[mn][i].n;

    return x;
}

/*  where
   $B$"$k<j$,$I$3$K$"$k$+$rD4$Y$^$9!#(B
   count $B$rMQ$$$k$[$I$8$c$J$$$H$-$K;H$$$^$9!#(B
 */
static RenjuCmd where(board_t b, int n, int t)
{
    int i, j;
    int mn, en;
    RenjuCmd cmd;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK && BAN(b, j, i).lose[mn] >= t) {
		cmd.type = CMD_PUT;
		cmd.x = j;
		cmd.y = i;
		return cmd;
	    }

    return cmd;
}

/*  think_to_win
   $B<+J,$N#5!"Aj<j$N#5!"<+J,$N#4#4!"<+J,$N:81&$,6u$$$F$$$k#4$rBG$A$^$9!#(B
   $B$3$l$i$N<j$O9M$($FBG$DI,MW$O$"$j$^$;$s!#(B
 */
static RenjuCmd think_to_win(board_t b, int n, counter_t c)
{
    int mn, en;
    RenjuCmd cmd;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    if (c[mn][T_WIN].n) {
	cmd.type = CMD_PUT;
	cmd.x = c[mn][T_WIN].x;
	cmd.y = c[mn][T_WIN].y;
	return cmd;
    }
    if (c[en][T_WIN].n) {
	cmd.type = CMD_PUT;
	cmd.x = c[en][T_WIN].x;
	cmd.y = c[en][T_WIN].y;
	return cmd;
    }
    if (c[mn][T_44].n) {
	cmd.type = CMD_PUT;
	cmd.x = c[mn][T_44].x;
	cmd.y = c[mn][T_44].y;
	return cmd;
    }
    if (c[mn][T_R4].n) {
	cmd.type = CMD_PUT;
	cmd.x = c[mn][T_R4].x;
	cmd.y = c[mn][T_R4].y;
	return cmd;
    }
    return cmd;
}

/*  think_my_43
   $B#4#3$rBG$D;~$O!"$=$N#4$rAj<j$,;_$a$?;~$K#4#3$J$I$NLr$,$G$-$J$$$h$&$K$7$^$9!#(B
   $BAj<j$KLr$,$G$-$k>l9g$O#4#3$rBG$A$^$;$s!J#3#3$O=|$-$^$9!K!#(B
 */
static RenjuCmd think_my_43(board_t b, int n, counter_t c)
{
    int mn, en;
    int i, j;
    board_t bb;
    RenjuCmd cmd, cmdx;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    if (c[mn][T_43].n == 0)
	return cmd;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK && BAN(b, j, i).lose[mn] == T_43) {
		cpboard(b, bb);
		put_koma(bb, n, j, i);
		cmdx = where(bb, n, T_5);
		if (cmdx.type == CMD_PUT)
		    if (BAN(bb, cmdx.x, cmdx.y).lose[en] >= T_43)
			return cmd;
		    else {
			cmd.type = CMD_PUT;
			cmd.x = j;
			cmd.y = i;
			return cmd;
		    }
	    }
    return cmd;

}

/*  think_your_win
   $BAj<j$NLr$r;_$a$k$H$-$O$=$l$G$9$Y$F$NLr$,$J$/$J$k$h$&$KBG$A$^$9!#(B
   $B$=$l$,L5M}$J$i<+J,$N#4$rBG$C$FAj<j$,Lr$r:n$k$N$r$G$-$k$@$1$"$H$K$7$^$9!#(B
   $B$3$l$K$h$C$F5UE>$N2DG=@-$b=P$F$-$^$9!#(B
   $B#4$O$G$-$k$@$1O"B3$9$k$h$&$KBG$A$^$9!#(B
   $B$3$N#4$rBG$C$F5UE>$G$-$k$H$-$O>/$J$$$G$9!#(B
   $B$7$+$7!"$3$NBG$AJ}$r2~A1$9$k$H>/$76/$/$J$k$G$7$g$&!#(B
   $B6qBNE*$K$O!"@hFI$_$G$G$-$k$@$1Lr$K;}$C$F$$$/$H$$$$$G$7$g$&!#(B
 */
static RenjuCmd think_your_win(board_t b, int n, counter_t c)
{
    int mn, en;
    int i, j;
    int x, y;
    int minn, tn, xn, mxn;
    counter_t cc;
    board_t bb;
    RenjuCmd cmd, cmdx;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    mxn = count_n(c, en, T_33);
    if (mxn == 0)
	return cmd;
    minn = mxn * 256 - count_n(c, mn, T_T3);
    x = y = -1;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK &&
		BAN(b, j, i).lose[mn] != T_LOSE &&
		BAN(b, j, i).lose[en] >= T_33) {
		cpboard(b, bb);
		put_koma(bb, n, j, i);
		count(bb, cc);
		xn = count_n(cc, en, T_33);
		tn = xn * 256 - count_n(cc, mn, T_T3)
		    + (Random() & 7);
		if (tn <= minn) {
		    x = j;
		    y = i;
		    minn = tn;
		    mxn = xn;
		}
	    }
    if (mxn == 0 || (c[mn][T_T4].n + c[mn][T_4].n == 0 && x >= 0)) {
	cmd.type = CMD_PUT;
	cmd.x = x;
	cmd.y = y;
	return cmd;
    }
    minn = INT_MAX;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK &&
		BAN(b, j, i).lose[mn] >= T_T4 &&
		BAN(b, j, i).lose[mn] != T_33) {
		cpboard(b, bb);
		put_koma(bb, n, j, i);
		cmdx = where(bb, n, T_5);
		if (cmdx.type == CMD_PUT) {
		    put_koma(bb, n + 1, cmdx.x, cmdx.y);
		    count(bb, cc);
		    tn = count_n(cc, en, T_43) * 256 - count_n(cc, mn, T_S3);
		    if (tn <= minn) {
			x = j;
			y = i;
			minn = tn;
		    }
		}
	    }
    if (x >= 0) {
	cmd.type = CMD_PUT;
	cmd.x = x;
	cmd.y = y;
	return cmd;
    }
    return cmd;
}

/*  think_my_33
   $B#3#3$OBG$C$F$$$$>u67!JAj<j$KLr$,$J$$$H$-!K$G$OL5>r7o$GBG$A$^$9!#(B
 */
static RenjuCmd think_my_33(board_t b, int n, counter_t c)
{
    int mn, en;
    RenjuCmd cmd;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    if (c[mn][T_33].n) {
	cmd.type = CMD_PUT;
	cmd.x = c[mn][T_33].x;
	cmd.y = c[mn][T_33].y;
	return cmd;
    }
    return cmd;
}

/*  think_win_33
   $BAj<j$K6X$8<j$,$"$j!"$=$l$,MxMQ$G$-$k$H$-$O$=$l$G>!$A$^$9!#(B
   $B6qBNE*$K$O!"<+J,$N#4$d#3$rAj<j$,6X$8<j$N0LCV$G;_$a$k$h$&$KBG$A$^$9!#(B
   $B$3$l$K$h$C$FAj<j$O#4$,;_$a$i$l$J$$$+!"6X$8<j$rBG$D$N$I$A$i$+$K$J$j$^$9!#(B
 */
static RenjuCmd think_win_33(board_t b, int n, counter_t c)
{
    int mn, en;
    int i, j;
    board_t bb;
    RenjuCmd cmd, cmdx;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    if (c[en][T_LOSE].n == 0)
	return cmd;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK &&
		BAN(b, j, i).lose[mn] != T_LOSE &&
		BAN(b, j, i).lose[en] == T_LOSE) {
		cpboard(b, bb);
		put_koma(bb, n, j, i);
		cmdx = where(bb, n, T_R4);
		if (cmdx.type == CMD_PUT) {
		    return cmd;
		}
	    }
    return cmd;
}

/*  think_my_attack
   $BLr$,$J$$>l9g!"$"$kDxEY$N$3$A$i$N967b$NL\$,$"$C$?$J$i$P(B
   $BO"B3$7$F#3$d#4$rBG$F$k$h$&$K#3!"#4$rBG$A$^$9!#(B
   $B$"$^$j9M$($F$J$$$N$G!"Aj<j$N<j$O$[$H$s$IL5;k$G$9!#(B
   $BAj<j$K#4$d#3$r:n$i$;$J$$$h$&$KBG$D$h$&$K$9$k$H$b$C$H6/$/$J$k$G$7$g$&!#(B
 */
static RenjuCmd think_my_attack(board_t b, int n, counter_t c)
{
    int mn, en;
    int i, j;
    int tn, maxn;
    int x, y;
    counter_t cc;
    board_t bb;
    RenjuCmd cmd;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    maxn = count_n(c, mn, T_T3);
    if (maxn < 7)
	return cmd;
    maxn -= count_n(c, en, T_T3);
    x = y = -1;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK && BAN(b, j, i).lose[mn] >= T_T3) {
		cpboard(b, bb);
		put_koma(bb, n, j, i);
		count(bb, cc);
		tn = count_n(cc, mn, T_T3) - count_n(c, en, T_T3)
		    + (Random() & 7);
		if (tn >= maxn) {
		    x = j;
		    y = i;
		    maxn = tn;
		}
	    }
    if (x >= 0) {
	cmd.type = CMD_PUT;
	cmd.x = x;
	cmd.y = y;
	return cmd;
    }
    return cmd;
}

static int t_defence[CNT_SIZE][CNT_SIZE] =
{
/*   lo  0   2   s3  t3  3   t4  tl  4   33  43  f4  44  win */  /* you  */
    {0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0},	/* lose */
    {0,  5, 15, 17, 17, 19, 22, 22, 25, 70, 80, 99, 99,  0},	/* 0    */
    {0, 18, 23, 25, 25, 28, 28, 28, 31, 70, 80, 99, 99,  0},	/* 2    */
    {0, 23, 27, 30, 30, 31, 33, 33, 36, 70, 80, 99, 99,  0},	/* s3   */
    {0, 13, 14, 16, 19, 19, 19, 19, 21, 70, 80, 99, 99,  0},	/* t3   */
    {0, 15, 16, 18, 21, 21, 21, 21, 23, 70, 80, 99, 99,  0},	/* 3    */
    {0, 18, 19, 21, 24, 24, 24, 24, 27, 70, 80, 99, 99,  0},	/* t4   */
    {0, 18, 19, 21, 24, 24, 24, 24, 27, 70, 80, 99, 99,  0},	/* tl   */
    {0, 19, 20, 22, 25, 25, 25, 25, 28, 70, 80, 99, 99,  0},	/* 4    */
    {0,  0,  0,  0,  0,  0,  0,  0,  0, 70, 80, 99, 99,  0},	/* 33   */
    {0,  0,  0,  0,  0,  0,  0,  0,  0, 70, 80, 99, 99,  0},	/* 43   */
    {0,  0,  0,  0,  0,  0,  0,  0,  0, 70, 80, 99, 99,  0},	/* f4   */
    {0,  0,  0,  0,  0,  0,  0,  0,  0, 70, 80, 99, 99,  0},	/* 44   */
    {0,  0,  0,  0,  0,  0,  0,  0,  0, 70, 80, 99, 99,  0}	/* win  */
};

/*  think_my_defence
   $B<i$j$N$H$-$G$9(B
   $BE,Ev$K7h$a$?>e$NI=$N=E$_$KMp?t$r2C$(!"$=$N$b$C$H$bBg$-$$$H$3$m$KBG$A$^$9!#(B
   $B$[$H$s$I!"9M$($F$^$;$s!#(B
   $B$3$3$O<g$K=xHW$K=EMW$K$J$j$^$9!#(B
   $B:#$O$3$l$GK~B-$7$F$$$^$9$,!"$3$3<!Bh$G$b$C$H6/$/$9$k$3$H$b2DG=$G$7$g$&!#(B
   $BDj@P$NAH$_9~$_Ey(B
*/
static RenjuCmd think_my_defence(board_t b, int n, counter_t c)
{
    int mn, en;
    int i, j;
    int x, y;
    int maxn, nn;
    RenjuCmd cmd;

    cmd.type = CMD_SKIP;
    mn = n & 1;
    en = 1 - mn;

    maxn = -1;
    x = y = -1;

    for (i = 0; i < BOARDSIZE; i++)
	for (j = 0; j < BOARDSIZE; j++)
	    if (BAN(b, j, i).koma == K_CHECK) {
		nn = t_defence[(int)BAN(b, j, i).lose[mn]]
				[(int)BAN(b, j, i).lose[en]]
		    + (Random() % 10);
		if (nn > maxn) {
		    maxn = nn;
		    x = j;
		    y = i;
		}
	    }
    if (x >= 0) {
	cmd.type = CMD_PUT;
	cmd.x = x;
	cmd.y = y;
	return cmd;
    }
    return cmd;
}

/*  think
   $B;W9M%k!<%A%sK\BN$G$9!#(B
   $B>e$N4X?t$r=g$K8F$S=P$7$F$$$k$@$1$G$9!#(B
   $B$"$^$j!"<j$r$$$l$kI,MW$O$J$$$G$7$g$&!#(B
 */
RenjuCmd think(board_t b, int n)
{
    int mn;
    counter_t c;
    RenjuCmd cmd;
    int nn;

    mn = n & 1;

    if (BAN(b, BOARDSIZE/2, BOARDSIZE/2).koma == K_CENTER) {
	cmd.type = CMD_PUT;
	cmd.x = BOARDSIZE/2;
	cmd.y = BOARDSIZE/2;
	return cmd;
    }

    /* $B<n7?$K9g$o$;$FBG$D(B */
    if (n == 0) {
	nn = Random() % JUKEI_MAX;
	cmd = Jukei[nn][0];
	return cmd;
    } else if (n == 1) {
	nn = Random() % JUKEI_MAX;
	cmd = Jukei[nn][1];
	if (BAN(b, cmd.x, cmd.y).koma >= K_NOTHING)
	    return cmd;
    } else if (n == 2) {
	if (BAN(b, BOARDSIZE/2, BOARDSIZE/2).koma == K_BLACK) {
	    cmd = Jukei[J_KANSETU][1]; /* $B4V@\7?(B */
	    nn = Random() % (JUKEI_MAX/2);
	    if (BAN(b, cmd.x, cmd.y).koma == K_WHITE) {
		cmd = Jukei[J_KANSETU+nn][2];
		return cmd;
	    }
	    cmd = Jukei[J_TYOKUSETU][1]; /* $BD>@\7?(B */
	    nn = Random() % (JUKEI_MAX/2);
	    if (BAN(b, cmd.x, cmd.y).koma == K_WHITE) {
		cmd = Jukei[J_TYOKUSETU+nn][2];
		return cmd;
	    }
	}
    }

    count(b, c);

    cmd = think_to_win(b, n, c);
    if (cmd.type == CMD_PUT)
	return cmd;

    cmd = think_my_43(b, n, c);
    if (cmd.type == CMD_PUT)
	return cmd;

    cmd = think_your_win(b, n, c);
    if (cmd.type == CMD_PUT)
	return cmd;

    if (mn == K_WHITE) {
	cmd = think_my_33(b, n, c);
	if (cmd.type == CMD_PUT)
	    return cmd;

	cmd = think_win_33(b, n, c);
	if (cmd.type == CMD_PUT)
	    return cmd;
    }

    cmd = think_my_attack(b, n, c);
    if (cmd.type == CMD_PUT)
	return cmd;

    cmd = think_my_defence(b, n, c);
    if (cmd.type == CMD_PUT)
	return cmd;

    return cmd;
}
