/*
   $B30It;W9M%k!<%A%s$N%5%s%W%k$G$9!#(B
   $BCf8+$O(Bthink.c$B$N(Bthink$B$r8F$S=P$7$F$k$@$1$G$9!#(B
   stdin$B$rD4$Y$F!"D>@\C<Kv$+$iF~NO$7$F$$$?$i(B($B$3$N=q$-J}$G$o$+$k$+$J(B?)
   $B%F%9%H%b!<%I$H$7$F!"%W%m%s%W%H$rI=<($7$^$9!#(B
   think(b, n, &cmd.x, &cmd.y) $B$r<+J,$N;W9M%k!<%A%s$K=q$-49$($k$H(B
   $B%*%j%8%J%k$N;W9M%k!<%A%s$,:n$l$^$9!#(B
   $B$=$N>l9g$O!"(Bput_koma$B$d(Bclear_board$B$r<+J,$N$b$N$K=q$-49$($F$b$$$$$G$7$g$&!#(B
*/

#include <stdio.h>
#include <unistd.h>

#include "renju.h"
#include "renjucmd.h"
#include "prototype.h"

#define TEST_MODE	0
#define NO_TEST		1

static void help(void)
{
    fputs("This is test mode.\n", stderr);
    fputs("Command is\n", stderr);
    fputs(" I)nitialize\n", stderr);
    fputs(" P)ut 00 - A\n", stderr);
    fputs(" T)hink\n", stderr);
    fputs(" S)kip (Pass)\n", stderr);
    fputs(" E)nd\n", stderr);
    fputs(" H)elp\n", stderr);
}

char *ord_char[] = {"Black", "White"};

int main(int argc, char *argv[])
{
    RenjuCmd cmd;
    board_t b;
    int n;
    int mode;
    char buf[256];

    mode = NO_TEST;
    if (isatty(0) || (argc > 1 && strcmp(argv[1], "-debug") == 0))
	mode = TEST_MODE;

    initJukei();
    clear_board(b);
    n = 0;

    if (mode == TEST_MODE) {
	help();
    }
    while (1) {
	if (mode == TEST_MODE)
	    fputs("> ", stderr);
	cmd = ReadCmdFile(stdin);

	switch (cmd.type) {
	case CMD_INIT:
	    if (mode == TEST_MODE)
		fputs("Initializing", stderr);

	    clear_board(b);
	    n = 0;

	    if (mode == TEST_MODE)
		fputs("... Done\n", stderr);
	    break;

	case CMD_PUT:
	    put_koma(b, n, cmd.x, cmd.y);
	    if (mode == TEST_MODE)
		fprintf(stderr, "You put %s on %s\n",
			ord_char[n & 1], posMessage(buf, cmd.x, cmd.y));
	    n++;
	    break;

	case CMD_THINK:
	    if (mode == TEST_MODE)
		fputs("Thinking", stderr);
	    cmd = think(b, n);
	    if (mode == TEST_MODE)
		fputs("... Done\n", stderr);
	    WriteCmdFile(stdout, cmd);
	    if (mode == TEST_MODE)
		fprintf(stderr, "I put %s on %s\n",
			ord_char[n & 1], posMessage(buf, cmd.x, cmd.y));
	    break;

	case CMD_SKIP:
	    if (mode == TEST_MODE)
		fputs("Skip (Pass)\n", stderr);
	    n++;
	    break;

	case CMD_END:
	    if (mode == TEST_MODE)
		fputs("End game.\n", stderr);
	    exit(0);

	case CMD_HELP:
	    if (mode == TEST_MODE)
		help();
	    break;
	}
    }

    return 0;
}
